#include <cstdio>
#include <algorithm>
#include <list>
#include <set>
#include <queue>
#include <cstring>
using namespace std;

#define REP(i,n) for(int i = 0; i < (n); ++i)
#define FOR(i,a,b) for(int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for(int i = (a); i >= (b); --i)
#define PRINTF(args...) printf(args)
// #define PRINTF(args...)


int n;

#define MAX 21
#define LE 4
#define INF 10000000

int plansza[2*MAX-1][2*MAX-1][LE];

queue<pair<int,int> >kolejka[LE];
int szerokosc[2*MAX-1];

int pary[LE][LE];
int trojki[LE][LE][LE];

void sprawdz(int i,pair<int,int> co, int x, int y)
{
  if(x==-1 or x==2*n or y==-1 or y==szerokosc[x])
    return;
  
  if(plansza[x][y][i] > plansza[co.first][co.second][i]+1)
  {
    plansza[x][y][i] = plansza[co.first][co.second][i]+1;
    kolejka[i].push(make_pair(x,y));
  }
 
}

int main() 
{
  while(true)
  {
    scanf("%d", &n);
    if(n==0)
      return 0;

    for(int i=0;i!=2*n-1;i++)
    {
      for(int j=0;j!=2*n-1;j++)
        for(int k=0;k!=LE;k++)
          plansza[i][j][k]=INF;

      if(i<n)
        szerokosc[i]=n+i;
      else
        szerokosc[i]=n+(2*n-i-2);
        printf("%d linijka ma szerokosc %d\n", i, szerokosc[i]);

      for(int j=0;j!=szerokosc[i];j++)
      {
        char temp[2];
        scanf("%s",temp);
        printf("%s\n",temp);
        if(temp[0]!='.')
        {
          plansza[i][j][temp[0]-'A']=0;
          kolejka[temp[0]-'A'].push(make_pair(i,j));
        }
      }
    }

    //po wczytaniu7
    for(int i=0;i!=LE;i++)
    {
      while(!kolejka[i].empty())
      {
        pair<int,int>temp=kolejka[i].front();
        kolejka[i].pop();
       
        sprawdz(i, temp, temp.first, temp.second-1);
        sprawdz(i, temp, temp.first, temp.second+1);

        if(temp.first<=n)  //TODO nierownosc
        {
          sprawdz(i, temp, temp.first-1, temp.second-1);
          sprawdz(i, temp, temp.first-1, temp.second);
        }
        else
        {
          sprawdz(i, temp, temp.first-1, temp.second+1);
          sprawdz(i, temp, temp.first-1, temp.second);
        }

        if(temp.first<n)
        {
          sprawdz(i, temp, temp.first+1, temp.second+1);
          sprawdz(i, temp, temp.first+1, temp.second);
        }
        else
        {
          sprawdz(i, temp, temp.first+1, temp.second-1);
          sprawdz(i, temp, temp.first+1, temp.second);
        }

      }
    }
      //konecze BFS
    for(int l1=0;l1!=LE;l1++)
      for(int l2=0;l2!=LE;l2++)
      {
        pary[l1][l2]=INF;
        if(l1==l2)
          continue;
        for(int i=0;i!=2*n-1;i++)
          for(int j=0;j!=szerokosc[i];j++)
          {
            if(pary[l1][l2]>plansza[i][j][l1]+plansza[i][j][l2]-1)
            {
              pary[l1][l2]=plansza[i][j][l1]+plansza[i][j][l2]-1;
            }
          }
      }

    for(int l1=0;l1!=LE;l1++)
      for(int l2=0;l2!=LE;l2++)
      {
        printf("polaczenie %d i %d kosztuje %d\n",l1,l2,pary[l1][l2]);
      }

    for(int l1=0;l1!=LE;l1++)
      for(int l2=0;l2!=LE;l2++)
        for(int l3=0;l3!=LE;l3++)
        {
          trojki[l1][l2][l3]=
        }
    


  }
}


